//$Id: SprTrainedGEP.cc,v 1.1 2008/02/22 23:07:50 narsky Exp $



#include "StatPatternRecognition/SprExperiment.hh"
#include "StatPatternRecognition/SprTrainedGEP.hh"
#include "StatPatternRecognition/SprUtils.hh"

#include <stdio.h>
#include <utility>
#include <cassert>

using namespace std;



SprTrainedGEP::SprTrainedGEP() 
  :  
  SprAbsTrainedClassifier() 
{
  // set cut on classifier output
  this->setCut(SprUtils::lowerBound(0.0));
}


SprTrainedGEP::SprTrainedGEP(const SprTrainedGEP& 
					     other)
  : 
  SprAbsTrainedClassifier(other)

{}

SprTrainedGEP::SprTrainedGEP(const SprChromosome &best) 
  :  
  SprAbsTrainedClassifier() 
{
  this->setCut(SprUtils::lowerBound(0.0));
  trainedChromosome_ = best;
}


double SprTrainedGEP::response(const std::vector<double>& v) const
{
	// sanity check
	assert( d_ < v.size() );

	// evaluate the best chrom. with the vector v
	return trainedChromosome_.Evaluate(v,0);
}



void SprTrainedGEP::print(std::ostream& os) const
{
  os << "Trained GEP " << SprVersion << endl;
}

